
const {log,helpers} = require('utils-nxg-cg');
const fs = require('fs');

const _ = require('lodash');
const vm = require('vm');
const { messages } = require('elasticio-node');
const co = require('co');
const request = require('co-request');

/**
 *
 * @param properties
 * @returns {Promise<Object>}
 */
let finalResult;
const transformXmlJson = async (properties) => {
        const vmExports = {};
        const ctx = vm.createContext({
            // Node Globals
            Buffer,
            clearInterval,
            clearTimeout,
            console,
            exports: vmExports,
            global: {},
            module: { exports: vmExports },
            process,
            require,
            setInterval,
            setTimeout,
            URL,
            URLSearchParams,

            // EIO Specific Functionality
            emitter: this,
            messages,
            msg,

            // Other Libraries
            _,
            request,
            wait: wait.bind(this),
        });
        vm.runInContext(properties.code, ctx, {
            displayErrors: true,
          });

        if (ctx.run && typeof ctx.run.apply === 'function') {
            let result;
            if (ctx.run.constructor.name === 'GeneratorFunction') {
            this.logger.debug('Run variable is a generator');
            const fn = co.wrap(ctx.run);
            result = fn.apply(this, [msg, conf, snapshot]);
            } else {
            this.logger.debug('Run variable is a function, calling it');
            result = ctx.run.apply(this, [msg, conf, snapshot]);
            }
            if (typeof result === 'object' && typeof result.then === 'function') {
            this.logger.debug('Returned value is a promise, will evaluate it');
            let returnResult;
            try {
                returnResult = await result;
                this.logger.debug('Promise resolved');
                if (returnResult) {
                return messages.newMessageWithBody(returnResult);
                }
                this.emit('end');
            } catch (e) {
                throw Error(e);
            }
            }
        } else {
            return("Run function was not found, it's over now");
          
        }

            
};



module.exports = {transformXmlJson};